#!/usr/bin/env python
''' authcodes.py
    contains list of valid authority/action codes as used by cgiutils.auth
    Add entry to list every time a new authority code is defined.
    to use this module:
import authcodes

'''
authcodes={
"LDGRVIEW":"view ledger",
"SUMRYVIEW":"view accounts summary",
"BALVIEW":"view balance",
"STATEMENT":"view a trading statement",
"FULLADDRVIEW":"view full member addresses",
"PAY":"make payment",
"REPUD":"repudiate payment",
"MEMBADD":"add member/account",
"MEMBMOD":"modify member/account details",
"SBALMOD":"modify starting balance",
"LIMITMOD":"modify debit limit",
"MEMBSTATUS":"change member account status",
"MEMBDEL":"delete member account",
"MEMBVIEW":"view member address details",
"LABELS":"view/display member postal address details",
"CATEGADD":"add trading category",
"CATEGMOD":"modify trading category",
"CATEGDEL":"delete trading category",
"WODEL":"delete want or offer",
"WOADD":"add want or offer",
"SECURITY":"use login security form",
"AUTHAUDIT":"use authorisation/audit form",
"AUTHADD":"grant authorisation",
"AUTHDEL":"revoke authorisation",
"AUTHVIEW":"view authorisations",
"AUDITVIEW":"view audit log",
"SMSGW":"perform SMS gateway phone to account to name lookups",
"ACCEPTREJECT":"approve or reject pending applications",
"APPLICATIONSVIEW":"view applications pending approval or rejection",
"YEAREND":"yearend processing to archive acks and access writeoff form",
"WRITEOFF":"writeoff dead accounts and perform book balancing functions",
"PINMOD":"reset a user PIN"
}

def codes():
  return list(authcodes.keys())

def htmltab():
  print('<table  align="center" bgcolor="#ffffff" border=2 >') 
  print('<tr><th> Code</th> <th> Description </th></tr>')
  for key in sorted(authcodes.keys()) :
    print('<tr>')
    print('<td>'+key+'</td>') 
    print('<td>'+authcodes[key]+'</td>') 
    print('</tr>')
  print('</table>') 
