#!/usr/bin/env python


''' make_live.py Richard Kay 2002 - 2010
# script to restart a PyLETS CGI database in live mode
# after use in testing modes. Alters permissions
# to restrict use of testing mode and restores paths
# to live data and configurations 
'''

import sys
import os,os.path,pickle

def main(tsmode='secure'):
  mode=open("mode.txt").read()
  if mode[-1] == '\n':
    mode=mode[:-1]
  if mode not in ['test','live']:
    raise ValueError("invalid mode.txt value must be test or live")
  if mode == 'live':
    print("system appears to be already in live mode")
    return
  # restore default_paths file
  os.system("cp default_paths_live.py default_paths.py")
  
  # inactivate further use of test scripts
  
  os.system("chmod -x testsuite/test*.py master_key.py")
  os.system("chmod -x test.cgi make_clean.py make_install.py")
  os.system("chmod -x make_test.py make_live.py")
  os.system("chmod ugo=  testsuite")
  print('make_live.py has removed access to test programs')
  import default_paths 
  cl=default_paths.cfg_directory
  print('Edit or confirm settings in site.cfg and secure.cfg in')
  print('directory '+cl+' before using live system.')
  mfh=open('mode.txt','w')
  mfh.write('live\n')
  mfh.close()

if __name__ == "__main__":
  try:
      main()
  except:
    import traceback
    print("error detected in make_live.py main()")
    traceback.print_exc()
