#!/usr/bin/env python

# make_test.py used to make a PyLETS system testable and initiate testing

import os,sys,os.path

def main():
  mode=open("mode.txt").read()
  if mode[-1] == '\n':
    mode=mode[:-1]
  if mode not in ['test','live']:
    raise ValueError("invalid mode.txt value must be test or live")
  if mode == 'test':
    print("system appears to be already in test mode") 
    return
  # set permissions to permit testing
  os.system("chmod 755 testsuite")
  os.system("chmod ug+x testsuite/test*.py test.cgi")
  os.system("chmod ug+x make_install.py")
  os.system("chmod ug+x make_clean.py master_key.py")

  # backup default_paths.py and then rewrite data_directory 
  # path for test data location 
  os.system("cp default_paths.py default_paths_live.py")
  print("backup of default_paths.py kept in default_paths_live.py")
  print("remember to restore this file after ending testing") 
  print("and before going live")
  print("using make_live.py")

  # make_install.py has a useful function to rewrite data path
  import make_install
  testdatapath=os.path.join(os.getcwd(),'testsuite/test_data') 
  make_install.rewrite_default_path(testdatapath,'data_directory')
  testconfigpath=os.path.join(os.getcwd(),'testsuite/test_configs') 
  make_install.rewrite_default_path(testconfigpath,'cfg_directory')
  print('to run test suite, edit site.cfg and test.cfg')
  print('in directory: '+testconfigpath)
  print('Then change to directory: '+os.path.join(os.getcwd(),'testsuite')) 
  print('and enter command ./all.py') 
  mfh=open('mode.txt','w')
  mfh.write('test\n')
  mfh.close()

if __name__ == "__main__":
  try:
      main()
  except:
    import traceback
    print("error detected in make_test.main()")
    traceback.print_exc()
