#!/usr/bin/env python

# make_tgz.py used to build a PyLETS source code distribution tar file  
# must be run inside PyLETS software directory containing sources
# to be distributed. Builds new tarball using file versions stored
# in package_defaults directory in preference to local site configured 
# versions of these files:
# site.cfg, test.cfg, secure.cfg, categories.pkl, default_paths.py 

import os,sys,os.path
#store contents of mode file
mode=open('mode.txt').read()
# make mode file live
open('mode.txt','w').write('live')
# set permissions to permit testing
os.system("chmod 755 testsuite")
os.system("chmod ug+x testsuite/test*.py test.cgi make_install.py")
os.system("chmod ug+x make_clean.py master_key.py")
# get rid of compiled .pyc files
os.system("rm *.pyc testsuite/*.pyc")
# get rid of Lockfile and other log files 
os.system("rm *.log")
# get version number and create directory
version=input('input version string e.g.  0.8js for John Smith V0.8 ')
versiondir='pylets_'+version
os.system("mkdir "+versiondir)
#
# copy files
#
os.system("cp * "+versiondir+" 2> /dev/null") 
os.system("cp -r forms "+versiondir) 
os.system("cp -r utils "+versiondir) 
os.system("cp -r testsuite "+versiondir) 
os.system("cp -r package_defaults "+versiondir)
cp_def_paths_command='cp package_defaults/default_paths.py '+versiondir 
os.system(cp_def_paths_command) 

# create tarfile
tarfile=versiondir+'.tgz'
# example of tar command: tar czvf pylets_0.8.tgz pylets_0.8 
tarcommand='tar czvf '+tarfile+' '+versiondir
os.system(tarcommand)
print('source tarfile package created: '+tarfile) 
#restore mode.txt file 
open('mode.txt','w').write(mode)
