#!/usr/bin/env python
# change top line to the path of the Python interpreter on your system

''' master_key.py 
    Use if access by admin account is blocked: 
    A. By a denial of service password guessing attack causing 
    unwanted lockouts. It adds an override record for the 
    admin account at a specified network address.
    B. Through not knowing the admin account PIN.
    C. By setting security configuration variable
    admin_has_superpowers:yes

    This program can either be run interactively without command
    line options, or automatically using options: 
    -o IP_ADDRESS   # sets admin login override for IP_ADDRESS 
    -p              # prints admin PIN 
    -s              # resets admin_has_superpowers to value: yes 
'''

import cgiutils
import tablcgi
import time
import sys
import os 
import make_configure 
from table_details import mtab,ovrid
site_vars=cgiutils.get_vars('site.cfg')
dl=site_vars['data_location']

def add_override(ipaddr=None):
    ovs=tablcgi.sq_table(ovrid,dir=dl)
    row={}
    row["ovid"]=ovs.get_nextnum()
    if not ipaddr:
      row["ip"]=input("IP address for which admin a/c to be accepted: ")
    else:
      row["ip"]=ipaddr
    if not ( cgiutils.is_ipv4addr(row["ip"]) or cgiutils.is_ipv6addr(row["ip"])):
      print("invalid IP address. a/c not overridden")
      return
    row["ar"]='accept'
    now=time.time()
    row["ac_id"]='admin'
    row["when"]=now
    row["expiry"]=now+(31*24*60*60) # expires in one month
    ovs.addrow(row)
    ovs.save()

def getadminpin():
    members=tablcgi.table(mtab,dir=dl)
    index=members.find("admin")
    pin=members.data[index]["pin"]
    return pin

def grant_superpowers(): 
    from default_paths import cfg_directory
    import make_configure 
    filename=os.path.join(cfg_directory,'secure.cfg')
    make_configure.modify_config_var(filename,'admin_has_superpowers','yes')

def main():
  # interactive use
  if len(sys.argv) == 1: 
    print("o   Add override to re-enable blocked admin login")
    print("p   To obtain admin PIN")
    print("s   To grant admin account superpowers")    
    print("q   To quit")
    option=input("enter o,p,s or q : ").lower()
    if option == 'o':
      add_override()
    elif option == 'p':
      pin=getadminpin()
      print("PIN for admin account is: "+str(pin))
    elif option == 's':
      grant_superpowers()
    return
  # automatic use
  option=sys.argv[1].lower()
  if option not in ['-o','-p','-s']:
    print("usage: master_key.py [ -o IP_Address | -p | -s ]")
    print("-o IP_Address   - add override so admin can login from IP_address")
    print("-p              - obtain admin PIN")
    print("-s              - set secure.cfg admin_has_superpowers value to yes")
    return
  if option == '-o' and len(sys.argv) == 2:
    print("-o override option requires IP address for admin login") 
    print("usage: master_key.py -o IP_Address ")
    return
  if option == '-o':
    ipaddr=sys.argv[2]
    add_override(ipaddr=ipaddr)
  elif option == '-p':
    pin=getadminpin()
    print("PIN for admin account is: "+str(pin))
  elif option == '-s':
    grant_superpowers()
  return
 
if __name__ == "__main__":
  try:
    main()
  except:
    import traceback
    print("error detected in master_key.main()")
    traceback.print_exc()

