#!/usr/bin/env python
# change top line to the path of the Python interpreter on your system

""" renew_allpins.py 
    one off data conversion to enable changed pins/passwords in members.pkl
    Either run this if you are increasing PIN sizes for security
    reasons, or if there has been a security exposure and new PINs need
    to be issued for all accounts.
"""

# uncomment next 3 lines to debug script
#import sys
#sys.stderr=sys.stdout
#print "Content-type: text/plain\n"

# configure next 2 lines as needed

minpin=10000000
maxpin=99999999

import cgiutils
import tablcgi
from table_details import mtab
site_vars=cgiutils.get_vars('site.cfg')
dl=site_vars['data_location']

def main():
  members=tablcgi.table(mtab,dir=dl)
  for row in members.data:
    newpin=cgiutils.make_pin(min=minpin,max=maxpin) 
    row["pin"]=newpin
    if row["ac_id"] == "admin":
      print("new admin pin is: "+str(newpin))
    members.modrow(row)
  members.save()

if __name__ == "__main__":
  try:
      main()
  except:
    import traceback
    print("error detected in renew_allpins main()")
    traceback.print_exc()

