#!/usr/bin/env python
''' test8.py Part B of Test suite for PyLETS CGI 

    test5.py - test8.py are designed to be used
    as a set.
    
    Purpose of tests: 
'''

def main(change_expected=False):
  print("\nTest Case 8: ack with all_can_record and members details update. \n")

  import testlib
  # get test configuation variables in dictionary v
  v=testlib.get_vars(savedpin=1)
  tv=testlib.get_vars(cfile='test.cfg')
  # need jill and adam's PIN
  jpin=testlib.get_userpin('jill')
  apin=testlib.get_userpin('adam')
  next_ack_id=testlib.get_nextackid()

  tests=[]
  testcase=8
  testno=0

  # test 1: checking jill can pay from jack to herself with who_can_ack all_can_record 

  testno+=1
  expected1='<p> Acknowledgment: %d successfully input.</p>' % next_ack_id
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'ack.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&from_id=jack&from_name=Jack&to_id=jill&to_name=Jill&amount=10.0&details=test ack made by jill to jill from jack' % jpin,
              'expected':expected1,
              'testno':testno,
              'description':'jill can acknowledge with who_can_ack as all_can_record' })

  # test 2: checking adam can make jack pay to jill with authorisation 

  testno+=1
  next_ack_id+=1
  expected2='<p> Acknowledgment: %d successfully input.</p>' % next_ack_id
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'ack.cgi',
              'data':'ac_id=adam&pin=%s&ua=admin&from_id=jack&from_name=Jack&to_id=jill&to_name=Jill&amount=10.0&details=test ack made by adam for jack to jill' % apin,
              'expected':expected2,
              'testno':testno,
              'description':'adam can make jack pay to jill with who_can_admin' })

  # test 3: jill cant modify her own membership address with errors 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&address=1^*New st Birmingham' % jpin ,
              'expected':'Invalid address.',
              'testno':testno,
              'description':'jill error modifying her membership address' })

  # test 4: jill can modify her own membership address 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&address=1 new st Birmingham' % jpin ,
              'expected':'1 field/s modified',
              'testno':testno,
              'description':'jill can modify her membership address' })

  # test 5: jill cant modify her own membership district with errors 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&district=Dot.()beth' % jpin ,
              'expected':' Invalid district use letters a-z and space only.',
              'testno':testno,
              'description':'jill error modifying her membership district' })

  # test 6: jill can modify her own membership district 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&district=Digbeth' % jpin ,
              'expected':'1 field/s modified',
              'testno':testno,
              'description':'jill can modify her membership district' })

  # test 7: jill cant modify her own membership postcode with errors 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&postcode=B4.*2SU' % jpin ,
              'expected':'Invalid postcode.',
              'testno':testno,
              'description':'jill error modifying her membership postcode' })

  # test 8: jill can modify her own membership postcode 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&postcode=B42 2SU' % jpin ,
              'expected':'1 field/s modified',
              'testno':testno,
              'description':'jill can modify her membership postcode' })

  # test 9: jill can view own membership details 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&view=view' % jpin ,
              'resultfile':'test'+str(testcase)+'_'+str(testno)+'.tst',
              'testno':testno,
              'description':'can view own membership details' })

  # test 10: jill cant modify her url format error 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&url=not-a.()domain' % jpin ,
              'expected':'URL parser reported: invalid url domain name format',
              'testno':testno,
              'description':'jill cant modify invalid url domain format' })

  # test 11: jill cant modify her url no host for domain 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&url=nota.subdomain.of.copsewood.net' % jpin ,
              'expected':'URL parser reported: invalid url domain name, no DNS record',
              'testno':testno,
              'description':'jill cant modify invalid domain no DNS host' })

  # test 12: jill can modify her valid url

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&modify=modify&url=http://www.python.org/' % jpin ,
              'expected':'1 field/s modified',
              'testno':testno,
              'description':'jill can modify valid url domain' })

  # test 13: jill can view own membership details with new url 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&view=view' % jpin ,
              'resultfile':'test'+str(testcase)+'_'+str(testno)+'.tst',
              'testno':testno,
              'description':'can view own membership details with url' })

  # test 14: jill can reset her PIN 

  testno+=1
  tests.append({'url':'http://'+tv['domain']+tv['testdir']+'mdetails.cgi',
              'data':'ac_id=jill&pin=%s&ua=user&rpin=rpin' % jpin ,
              'expected':'PIN emailed for account: jill',
              'testno':testno,
              'description':'jill can reset her pin' })

  # do all stored tests
  testlib.run_tests(tests,change_expected=change_expected)
  # restore config
  testlib.modify_config_var('test_configs/secure.cfg','who_can_ack','ac_can_pay')

if __name__ == "__main__":
  main()
