#!/usr/bin/env python
# change next line to debug=1 to debug

debug=1

""" upload.cgi This file handles input from the  
    cdetails.form part 2 used to upload a user photo. 
    Richard Kay 2010
"""

# uncomment next 3 lines to debug script

if debug:
  import sys
  sys.stderr=sys.stdout
  print("Content-type: text/plain\n")

import cgi, sys, os
import cgitb; cgitb.enable()
form = cgi.FieldStorage()
import cgiutils
#import webinput
#woi=webinput.Webinput()
import tablcgi
from table_details import mtab
site_vars=cgiutils.get_vars('site.cfg')
dl=site_vars['data_location']

def do_upload(session,ac_id):
  fn=None
  import os, os.path
  if 'filename' in form:
    fileitem = form['filename']
    fn = os.path.basename(fileitem.filename)
    photodir=dl+'/photos/'
    #open(dl+'/photos/' + fn, 'wb').write(fileitem.file.read())
    #message = 'The file "' + fn + '" was uploaded successfully'
  else:
    errmes = 'No file item was uploaded (trap 1)'
    cgiutils.html_end(session,error=errmes)
    return
  #if debug: print 'type: '+str(type(fileitem))
  #if debug: print 'attributes: '+str( dir(fileitem) )
  # Test if the file was uploaded
  if fn:
    # strip leading path from file name to avoid 
    # directory traversal attacks
    fn = os.path.basename(fileitem.filename.replace("\\", "/" ))
    # read up to 1% more than the maximum allowed to see if max exceeded
    # note that 1K is 1024 bytes 
    filestr=fileitem.file.read(int(site_vars['maximagesize']) * 1034)
    # check if the maximum upload exceeded
    if len(filestr) > int(site_vars['maximagesize'])*1024:
      errmes = 'Uploaded file size is too large. Sorry. Please reduce filesize.'
      cgiutils.html_end(session,error=errmes)
      return
    # create filename including some entropy for privacy reasons.
    # You want to check the photos directory is not browser visible,
    # otherwise unauthenticated clients can see and click the filenames 
    entropy=str(cgiutils.make_pin(mini=10000000,maxi=99999999))
    if not os.path.isdir(photodir):
      os.mkdir(photodir) 
    #open(dl+'/photos/' + fn, 'wb').write(fileitem.file.read())
    #message = 'The file "' + fn + '" was uploaded successfully'
    picfile=os.path.join(photodir,ac_id+'_'+entropy+'.pic')
    if debug: print('picfile: '+picfile)
    # write upload to file 
    open(picfile, 'wb').write(fileitem.file.read())
    # now obtain file type using shell file(1) command
    import subprocess
    typestr=subprocess.Popen(['file','-b',picfile],
            stdout=subprocess.PIPE).communicate()[0] 
    # if debug: print "filetype: "+typestr
    typestr4=typestr[0:4] 
    if typestr4 not in ['JPEG','PNG ']:
      errmes='<p>The file program said the filetype was '+typestr
      errmes+='\nThis does not look like a JPEG or a PNG photo file.\n'
      errmes+='So this file is rejected. Sorry.</p>\n'
      cgiutils.html_end(session,error=errmes)
      os.unlink(picfile)
      return
    # store filename in members table
    members=tablcgi.table(mtab,dir=dl)
    midx=members.find(ac_id)
    if midx == -1:
      raise ValueError("invalid account id - how did this get here ?")
    status=members.data[midx]['active']
    if ( site_vars['provisional_can_photo'].upper() == 'N' and 
        status == 'P' ) : 
      errmes = 'Site policy prevents provisional members uploading a photo.'
      cgiutils.html_end(session,error=errmes)
      os.unlink(picfile)
      return
    oldpicfile=members.data[midx]['pic']
    if oldpicfile == 'None':
      pass # null value for field
    else:
      # unlink old file for this member if it exists
      if os.path.isfile(oldpicfile):
        os.unlink(oldpicfile)
    members.data[midx]['pic']=picfile
    members.save()
    message = 'The file "' + fn + '" was uploaded successfully'
    print(message)
    cgiutils.html_end(session,received=1)
    return
  else:
    errmes = 'No file was uploaded (trap 2)'
    cgiutils.html_end(session,error=errmes)
    return
    
def main():
  session=False
  cgiutils.html_header(title="PyLETS Photo Upload request")
  valid,ac_id,pincookie,ua=cgiutils.get_hidden(woi)
  if not valid:
    return # error message already sent
  # check pin_or_cookie and account
  session=cgiutils.login(ac_id,pincookie,ua)
  valid=session.login()
  cookie=session.cookie
  if not valid:
    cgiutils.html_end(session,error="Invalid or stale or logged out session.")
    return
  #  
  do_upload(session,ac_id) 

if __name__ == "__main__":
  try: 
    main()
  except:
    import traceback
    print("error detected in upload.cgi main()")
    traceback.print_exc()

